#!/usr/bin/env python3

import sys

# takes an ass file and shows how many messages there are within a 30sec window at each time
# for example to see where a youtube/twitch chatlog is hype
# (see https://ocv.me/dev/?softchat.py for that)

stack = []
basets = 0
maxnum = 0
maxts = 0
with open(sys.argv[1], 'rb') as f:
    for ln in [x.decode('utf-8', 'ignore') for x in f]:
        if not ln.startswith('Dialogue: 0,'):
            continue

        ts = ln.split(',')[1].split(':')
        ts = 60 * (60 * int(ts[0]) + int(ts[1])) + float(ts[2])
        rm = 0
        for v in stack:
            if v < ts - 10:
                rm += 1

        stack = stack[rm:] + [ts]
        if maxnum < len(stack):
            maxnum = len(stack)
            maxts = ts

        if ts > basets + 30:
            print('{} {}'.format(maxnum, maxts))
            basets = ts
            maxnum = 0
            maxts = 0


r""" ame
88 16394.74
88 2998.95
88 4166.88
88 6152.25
91 513.75
91 7900.37
92 10174.75
93 2930.01
93 3196.47
95 2192.93
99 18126.47  <<safe
105 6780.24
127 17810.57

mpv ame-minecraft-railway-research-2.json.mkv --vo=direct3d --vf=fps=90 --sub-delay=-3 -ss 17800

..\dev\softchat.py -m 2 "ame-minecraft-railway-research-2.json" --sz 36 --spd 384

"""
